Bug 969952 - Link missing and implementation is missing
Link missing and implementation is missing
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: jboss-as (Show other bugs)
18
Unspecified Unspecified
high Severity high
: ---
: ---
Assigned To: Marek Goldmann
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-03 03:20 EDT by Sebastien Pasche
Modified: 2014-02-05 18:10 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-05 18:10:41 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Sebastien Pasche 2013-06-03 03:20:03 EDT
Description of problem:

Can't run properly a software depend on saaj (cxf)

The problem appear at the first call of the implementation (at soap envelope creation) after the deployment and of course after the loading of the module by the class loader.

It's look like a missing implementation.

The exception is : 

Caused by: java.lang.NoClassDefFoundError: com/sun/xml/messaging/saaj/soap/SOAPDocumentImpl
        at com.sun.xml.messaging.saaj.soap.SOAPPartImpl.<init>(SOAPPartImpl.java:106)
        at com.sun.xml.messaging.saaj.soap.ver1_1.SOAPPart1_1Impl.<init>(SOAPPart1_1Impl.java:70)
        at com.sun.xml.messaging.saaj.soap.ver1_1.Message1_1Impl.getSOAPPart(Message1_1Impl.java:90)
        at org.apache.cxf.binding.soap.saaj.SAAJOutInterceptor.handleMessage(SAAJOutInterceptor.java:125)
        at org.apache.cxf.jaxws.handler.soap.SOAPHandlerInterceptor.handleMessage(SOAPHandlerInterceptor.java:120)
        at org.apache.cxf.jaxws.handler.soap.SOAPHandlerInterceptor.handleMessage(SOAPHandlerInterceptor.java:71)
        at org.apache.cxf.phase.PhaseInterceptorChain.doIntercept(PhaseInterceptorChain.java:262)
        at org.apache.cxf.endpoint.ClientImpl.doInvoke(ClientImpl.java:531)
        at org.apache.cxf.endpoint.ClientImpl.invoke(ClientImpl.java:464)
        at org.apache.cxf.endpoint.ClientImpl.invoke(ClientImpl.java:367)
        at org.apache.cxf.endpoint.ClientImpl.invoke(ClientImpl.java:320)
        at org.apache.cxf.frontend.ClientProxy.invokeSync(ClientProxy.java:89)
        at org.apache.cxf.jaxws.JaxWsClientProxy.invoke(JaxWsClientProxy.java:134)
        at com.sun.proxy.$Proxy113.login(Unknown Source)
        at com.ieffects.sync.server.LoginService.login(LoginService.java:37) [server-v6.jar:]
        at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method) [rt.jar:1.7.0_19]
        at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:57) [rt.jar:1.7.0_19]
        at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43) [rt.jar:1.7.0_19]
        at java.lang.reflect.Method.invoke(Method.java:601) [rt.jar:1.7.0_19]
        at org.jboss.as.ee.component.ManagedReferenceMethodInterceptorFactory$ManagedReferenceMethodInterceptor.processInvocation(ManagedReferenceMethodInterceptorFactory.java:72) [jboss-as-ee-7.1.1.Final.jar:7.1.1.Final]
        at org.jboss.invocation.InterceptorContext.proceed(InterceptorContext.java:288) [jboss-invocation.jar:1.1.1.Final]
        at org.jboss.invocation.WeavedInterceptor.processInvocation(WeavedInterceptor.java:53) [jboss-invocation.jar:1.1.1.Final]
        at org.jboss.as.ee.component.interceptors.UserInterceptorFactory$1.processInvocation(UserInterceptorFactory.java:36) [jboss-as-ee-7.1.1.Final.jar:7.1.1.Final]
        at org.jboss.invocation.InterceptorContext.proceed(InterceptorContext.java:288) [jboss-invocation.jar:1.1.1.Final]
        at org.jboss.as.jpa.interceptor.SBInvocationInterceptor.processInvocation(SBInvocationInterceptor.java:47) [jboss-as-jpa-7.1.1.Final.jar:7.1.1.Final]
        at org.jboss.invocation.InterceptorContext.proceed(InterceptorContext.java:288) [jboss-invocation.jar:1.1.1.Final]
        at org.jboss.invocation.InitialInterceptor.processInvocation(InitialInterceptor.java:21) [jboss-invocation.jar:1.1.1.Final]
        at org.jboss.invocation.InterceptorContext.proceed(InterceptorContext.java:288) [jboss-invocation.jar:1.1.1.Final]
        at org.jboss.invocation.ChainedInterceptor.processInvocation(ChainedInterceptor.java:61) [jboss-invocation.jar:1.1.1.Final]
        at org.jboss.as.ee.component.interceptors.ComponentDispatcherInterceptor.processInvocation(ComponentDispatcherInterceptor.java:53) [jboss-as-ee-7.1.1.Final.jar:7.1.1.Final]
        at org.jboss.invocation.InterceptorContext.proceed(InterceptorContext.java:288) [jboss-invocation.jar:1.1.1.Final]
        at org.jboss.as.ejb3.component.pool.PooledInstanceInterceptor.processInvocation(PooledInstanceInterceptor.java:51) [jboss-as-ejb3-7.1.1.Final.jar:7.1.1.Final]
        at org.jboss.invocation.InterceptorContext.proceed(InterceptorContext.java:288) [jboss-invocation.jar:1.1.1.Final]
        at org.jboss.as.ejb3.tx.CMTTxInterceptor.invokeInOurTx(CMTTxInterceptor.java:228) [jboss-as-ejb3-7.1.1.Final.jar:7.1.1.Final]
        ... 52 more


To solve the actual problem I've done following : 


 - The package seem to install a part of saaj but don't do linking plumbing
ln -s /usr/share/java/jboss-saaj-1.3-api.jar

 - The package seem to not be shipped with implementation so I have to import it from the offical jboss zip archive

saaj-impl-1.3.16-jbossorg-1.jar copied /opt/jboss-as/modules/com/sun/xml/messaging/saaj/main/saaj-impl-1.3.16-jbossorg-1.jar

Then I modify the module.xml file like this : 

<module xmlns="urn:jboss:module:1.1" name="com.sun.xml.messaging.saaj">
    <properties>
        <property name="jboss.api" value="private"/>
    </properties>

    <resources>
        <!--resource-root path="glassfish-saaj.jar"/-->
        <resource-root path="jboss-saaj-1.3-api.jar" />
        <resource-root path="saaj-impl-1.3.16-jbossorg-1.jar" />
        <!-- Insert resources here -->
    </resources>

    <dependencies>
        <module name="javax.api" />
        <module name="javax.xml.soap.api" />
        <module name="org.apache.xerces" services="import" />
    </dependencies>

</module>

And now everything run fine

Information : 

THe software run correctly from the official jboss zip

Version-Release number of selected component (if applicable):

With yum install jboss* (everything and javadoc)

# rpm -qa | grep saaj
geronimo-saaj-1.1-7.fc18.noarch
glassfish-saaj-1.3.19-1.fc18.noarch
jboss-saaj-1.3-api-1.0.2-3.fc18.noarch
jboss-saaj-1.3-api-javadoc-1.0.2-3.fc18.noarch

# rpm -qa | grep cxf
jbossws-cxf-javadoc-4.1.0-2.fc18.noarch
cxf-xjc-utils-2.6.0-3.fc18.noarch
cxf-rt-2.6.3-4.fc18.noarch
jbossws-cxf-4.1.0-2.fc18.noarch
cxf-2.6.3-4.fc18.noarch
cxf-tools-2.6.3-4.fc18.noarch
cxf-api-2.6.3-4.fc18.noarch
cxf-services-2.6.3-4.fc18.noarch

How reproducible:

Install jboss, then install jboss-saaj and try use an cxf dependent software

Steps to Reproduce:
1. install jboss
2. deploy an app using cxf

Actual results:

Application is deploying but crash on first cxf call

Expected results:

A nice and shinny (as shinny soap can be ...) soap service

Additional info:

Working out of the box from the official zip package
Comment 1 Sebastien Pasche 2013-06-03 03:29:10 EDT
jboss log as information : http://fpaste.org/16172/70244535/
Comment 2 Sebastien Pasche 2013-06-03 04:10:34 EDT
After having rebuild a completely clean environment there is log we obtain : 

here is boot.log : http://fpaste.org/16177/02466451/
and server.log : http://fpaste.org/16179/46769137/
Comment 3 Marek Goldmann 2013-06-05 05:55:25 EDT
Let me look at this.
Comment 4 Marek Goldmann 2013-06-05 06:25:43 EDT
Please try this workaround. Edit the /usr/share/jboss-as/modules/com/sun/xml/messaging/saaj/main/module.xml file and replace the content with this:

<module xmlns="urn:jboss:module:1.1" name="com.sun.xml.messaging.saaj">
    <properties>
        <property name="jboss.api" value="private"/>
    </properties>

    <resources>
        <resource-root path="glassfish-saaj.jar"/>
        <!-- Insert resources here -->
    </resources>

    <dependencies>
        <system>
            <paths>
                <path name="com/sun/org/apache/xerces/internal"/>
            </paths>
        </system>
        <module name="javax.api" />
        <module name="javax.xml.soap.api" />
        <module name="org.apache.xerces" services="import" />
    </dependencies>

</module>

Make sure you have the glassfish-saaj.jar linked to the latest jar provided by Fedora. Please re-test your app afterwards and let me know if this fixed the issue.
Comment 5 Sebastien Pasche 2013-06-06 07:59:25 EDT
Not working :(

Cat of the Module.xml  + path : http://fpaste.org/16944/70518936/
Cat of the link and version glassfish_saaj : http://fpaste.org/16946/13705190/

Jboss error logs jboss : http://fpaste.org/16948/13705192/
Comment 6 Fedora End Of Life 2013-12-21 10:32:24 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 7 Fedora End Of Life 2014-02-05 18:10:41 EST
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.